import java.applet.*;
import java.awt.*;
import java.util.*;

// define a class that stores a secret number
class Obsable extends Observable {
    private int secretNumber;
	private Random generator;

    public Obsable(int seed) {
		// create a random number generator that will
		// make the "secret numbers"
		generator = new Random(seed);
    }

    public void GenerateNumber() {
		// generate a new secret number
		secretNumber = generator.nextInt();
		// indicate to Observable that the instance has changed
        setChanged();
		// notify all of the observers and pass the new number
        notifyObservers(new Integer(secretNumber));
    }
}


public class EX11E extends Applet implements Observer
{
    Integer secretNumber;
	Obsable obs;
	TextField tf;

	public EX11E() 
	{
		// create a new instance of the observable class
		obs = new Obsable(12);
		// indicate that "this" is an observer
		obs.addObserver(this);

		// create a read-only TextField
		tf = new TextField(10);
		tf.setEditable(false);
	}


	// this method is invoked when the observable object
	// notifies its observers
    public void update(Observable o, Object arg) {
		// store the secret number and display it
        secretNumber = (Integer)arg;
		tf.setText(String.valueOf(secretNumber));
    }

    public void init() {
		add(new Label("Secret Number:"));
		add(tf);
		add(new Button("Change"));
		resize(320, 240);
    }

    public boolean action(Event evt, Object obj)
    {
        boolean result=false;

        if("Change".equals(obj)) {
			obs.GenerateNumber();
            result = true;
        }
        return result;
    }

}

